#ifndef LIS3MDL_H_
#define LIS3MDL_H_

#include "stm32f4xx_hal.h"
#include <string.h>
//------------------------------------------------
#define ABS(x)         (x < 0) ? (-x) : x
//------------------------------------------------
#define LD2_Pin GPIO_PIN_5
#define LD2_GPIO_Port GPIOA
#define LD2_ON HAL_GPIO_WritePin(GPIOA, GPIO_PIN_5, GPIO_PIN_SET) //GREEN
#define LD2_OFF HAL_GPIO_WritePin(GPIOA, GPIO_PIN_5, GPIO_PIN_RESET)
//------------------------------------------------
#define MAG_I2C_ADDRESS	0x3C
//------------------------------------------------
#define	LIS3MDL_MAG_WHO_AM_I_REG	0X0F
#define LIS3MDL_MAG_CTRL_REG1	0X20
#define	LIS3MDL_MAG_CTRL_REG2	0X21
#define	LIS3MDL_MAG_CTRL_REG3	0X22
#define LIS3MDL_MAG_CTRL_REG5	0X24
//------------------------------------------------
#define	LIS3MDL_MAG_WHO_AM_I	0x3D
//------------------------------------------------
#define	LIS3MDL_MAG_MD_CONTINUOUS	0x00
#define	LIS3MDL_MAG_MD_SINGLE	0x01
#define	LIS3MDL_MAG_MD_POWER_DOWN	0x02
#define	LIS3MDL_MAG_MD_POWER_DOWN_AUTO	0x0
#define	LIS3MDL_MAG_MD_MASK	0x03
//------------------------------------------------
#define	LIS3MDL_MAG_BDU_DISABLE	0x00
#define	LIS3MDL_MAG_BDU_ENABLE	0x40
#define	LIS3MDL_MAG_BDU_MASK	0x40
//------------------------------------------------
#define	LIS3MDL_MAG_DO_0_625Hz	0x00
#define	LIS3MDL_MAG_DO_1_25Hz	0x04
#define	LIS3MDL_MAG_DO_2_5Hz	0x08
#define	LIS3MDL_MAG_DO_5Hz	0x0C
#define	LIS3MDL_MAG_DO_10Hz	0x10
#define	LIS3MDL_MAG_DO_20Hz	0x14
#define	LIS3MDL_MAG_DO_40Hz	0x18
#define	LIS3MDL_MAG_DO_80Hz	0x1C
#define	LIS3MDL_MAG_DO_MASK	0x1C
//------------------------------------------------
#define	LIS3MDL_MAG_FS_4Ga	0x00
#define	LIS3MDL_MAG_FS_8Ga	0x20
#define	LIS3MDL_MAG_FS_12Ga	0x40
#define	LIS3MDL_MAG_FS_16Ga	0x60
#define	LIS3MDL_MAG_FS_MASK	0x60
//------------------------------------------------
#define	LIS3MDL_MAG_OM_LOW_POWER	0x00
#define	LIS3MDL_MAG_OM_MEDIUM	0x20
#define	LIS3MDL_MAG_OM_HIGH	0x40
#define	LIS3MDL_MAG_OM_ULTRA_HIGH	0x60
#define	LIS3MDL_MAG_OM_MASK	0x60
//------------------------------------------------
#define	LIS3MDL_MAG_TEMP_EN_DISABLE	0x00
#define	LIS3MDL_MAG_TEMP_EN_ENABLE	0x80
#define	LIS3MDL_MAG_TEMP_EN_MASK	0x80
//------------------------------------------------
#define LIS3MDL_MAG_OUTX_L    0X28
#define LIS3MDL_MAG_OUTX_H    0X29
#define LIS3MDL_MAG_OUTY_L    0X2A
#define LIS3MDL_MAG_OUTY_H    0X2B
#define LIS3MDL_MAG_OUTZ_L    0X2C
#define LIS3MDL_MAG_OUTZ_H    0X2D
//------------------------------------------------
void Mag_Ini(void);
void Mag_Read(void);
//------------------------------------------------
#endif /* LIS3MDL_H_ */
